Package org.springframework.web.servlet.config.annotation

# Class ViewControllerRegistry

java.lang.Object
org.springframework.web.servlet.config.annotation.ViewControllerRegistry

public class ViewControllerRegistry extends Object
Assists with the registration of simple automated controllers pre-configured with status code and/or a view.

Since:
  3.1
Author:
  Rossen Stoyanchev, Keith Donald

## Constructor Summary

Constructors
Constructor
Description
`ViewControllerRegistry(org.springframework.context.ApplicationContext applicationContext)`
Class constructor with `ApplicationContext`.

## Method Summary

Modifier and Type
Method
Description
`RedirectViewControllerRegistration`
`addRedirectViewController(String urlPath, String redirectUrl)`
Map a view controller to the given URL path or pattern in order to redirect to another URL.
`void`
`addStatusController(String urlPath, org.springframework.http.HttpStatusCode statusCode)`
Map a simple controller to the given URL path (or pattern) in order to set the response status to the given code without rendering a body.
`ViewControllerRegistration`
`addViewController(String urlPathOrPattern)`
Map a URL path or pattern to a view controller to render a response with the configured status code and view.
`protected SimpleUrlHandlerMapping`
`buildHandlerMapping()`
Return the `HandlerMapping` that contains the registered view controller mappings, or `null` for no registrations.
`void`
`setOrder(int order)`
Specify the order to use for the `HandlerMapping` used to map view controllers relative to other handler mappings configured in Spring MVC.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### ViewControllerRegistry

public ViewControllerRegistry(@Nullable org.springframework.context.ApplicationContext applicationContext)
Class constructor with `ApplicationContext`.

Since:
  4.3.12

## Method Details

### addViewController

public ViewControllerRegistration addViewController(String urlPathOrPattern)
Map a URL path or pattern to a view controller to render a response with the configured status code and view.

Patterns such as `"/admin/**"` or `"/articles/{articlename:\\w+}"` are supported. For pattern syntax see `PathPattern` when parsed patterns are `enabled` or `AntPathMatcher` otherwise. The syntax is largely the same with `PathPattern` more tailored for web usage and more efficient.

Note: If an `@RequestMapping` method is mapped to a URL for any HTTP method then a view controller cannot handle the same URL. For this reason it is recommended to avoid splitting URL handling across an annotated controller and a view controller.

### addRedirectViewController

public RedirectViewControllerRegistration addRedirectViewController(String urlPath, String redirectUrl)
Map a view controller to the given URL path or pattern in order to redirect to another URL.

For pattern syntax see `PathPattern` when parsed patterns are `enabled` or `AntPathMatcher` otherwise. The syntax is largely the same with `PathPattern` more tailored for web usage and more efficient.

By default the redirect URL is expected to be relative to the current ServletContext, i.e. as relative to the web application root.

Since:
  4.1

### addStatusController

public void addStatusController(String urlPath, org.springframework.http.HttpStatusCode statusCode)
Map a simple controller to the given URL path (or pattern) in order to set the response status to the given code without rendering a body.

For pattern syntax see `PathPattern` when parsed patterns are `enabled` or `AntPathMatcher` otherwise. The syntax is largely the same with `PathPattern` more tailored for web usage and more efficient.

Since:
  4.1

### setOrder

public void setOrder(int order)
Specify the order to use for the `HandlerMapping` used to map view controllers relative to other handler mappings configured in Spring MVC.

By default this is set to 1, i.e. right after annotated controllers, which are ordered at 0.

### buildHandlerMapping

@Nullable protected SimpleUrlHandlerMapping buildHandlerMapping()
Return the `HandlerMapping` that contains the registered view controller mappings, or `null` for no registrations.

Since:
  4.3.12